/* sc-crontab.c
 * SommerCampus 2006
 * Linux/Unix Systemprogrammierung
 *
 * Licence: GPL-2 */

#include "sc-crontab.h"

int main(int argc, char **argv)
{
	uid_t uid, euid;
	char username[32], eusername[32], editor[32], *tmp, path[1024];
	struct passwd *uinfo;
	
	if(argc > 2)
	{
		fprintf(stderr, "usage: %s [user]\n", argv[0]);
		return EXIT_FAILURE;
	}

	euid = uid = getuid();

	uinfo = getpwuid(uid);
	strcpy(username, uinfo->pw_name);
	strcpy(eusername, uinfo->pw_name);

	if(argc == 2)
	{
		if(uid && strcmp(argv[1], username))
		{
			fprintf(stderr, "You are not superuser\n");
			return EXIT_FAILURE;
		}

		if(!uid && strcmp(argv[1], "root"))
		{
			uinfo = getpwnam(argv[1]);

			if(!uinfo)
			{
				fprintf(stderr, "could not get information of user %s\n", argv[1]);
				return EXIT_FAILURE;
			}

			strcpy(eusername, argv[1]);
			euid = uinfo->pw_uid;
		}
	}

	tmp = getenv("EDITOR");

	if(!tmp)
	{
		fprintf(stderr, "Environment variable $EDITOR not set\n");
		return EXIT_FAILURE;
	}

	strcpy(editor, tmp);

	sprintf(path, "%s/%s", SPOOLER "/crontabs", eusername);

	if(setuid(0))
	{
		fprintf(stderr, "Internal error\n");
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}
